package com.knauf.ejb.kuchen;

import java.rmi.RemoteException;
import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.EJBHome;
import javax.ejb.FinderException;

/**
 * Title:
 * Description:  Home-Interface des leckeren Kuchens.
 *               Deklariert die diversen Create-Methoden.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface KuchenSingleHome extends EJBHome
{
  /**Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird. Der Key wird (hoffentlich)
   * vom Container erzeugt.
   * @param str_Name Der Name des Kuchens.
   * @return Der erzeugte Kuchen.
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public KuchenSingle createByName (String str_Name) throws CreateException, RemoteException;

  /**Erzeugen eines Kuchen-Objekts, Name ist noch nicht gegeben. Der Key wird (hoffentlich)
   * vom Container erzeugt.
   * @return Der erzeugte Kuchen.
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public KuchenSingle create () throws CreateException, RemoteException;

  /**Laden eines Kuchen-Objekts anhand des Primary Keys.
   * @return Den anhand des Keys gefundenen Kuchen.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public KuchenSingle findByPrimaryKey(Object obj_PrimaryKey) throws FinderException, RemoteException;

  /**Laden aller Kuchen-Objekte.
   * @return Eine Collection aller Kuchen.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Collection findAll() throws FinderException, RemoteException;
}