package com.knauf.ejb.kuchenzutat;

import java.rmi.RemoteException;
import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBLocalHome;

/**
 * Title:
 * Description:  Local-Home-Interface fr eine Zutat.


 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface LocalZutatHome extends EJBLocalHome
{
  /**Erzeugen eines Zutat-Objekts, wobei Name und Menge angegeben wird. Der Key wird automatisch in
   * der Bean erzeugt.
   * @param str_Name Der Name der Zutat.
   * @param str_Menge Die Menge der Zutat
   * @return Die erzeugte Zutat
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutat createByNameMenge (String str_Name, String str_Menge) throws CreateException, RemoteException;

  /**Erzeugen eines Zutat-Objekts, Name und Menge sind noch nicht gegeben. Der Key wird automatisch in
   * der Bean erzeugt.
   * @return Die erzeugte Zutat
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutat create () throws CreateException, RemoteException;

  /**Laden einer Zutat anhand des Primary Keys.
   * @param int_PrimaryKey Der Primrschlssel der Zutat.
   * @return Die anhand des Keys gefundenen Zutat.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutat findByPrimaryKey(Integer int_PrimaryKey) throws FinderException, RemoteException;


  /**Laden aller Zutat-Objekte.
   * @return Eine Collection aller Zutaten.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Collection findAll() throws FinderException, RemoteException;

  /**Ermitteln der nchsten Zutat-ID.
   * D.h: Es wird Max(ID) + 1 zurckgeliefert.
   * @return Maximale Zutat-ID + 1
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Integer getNextId() throws RemoteException;
}