package com.knauf.ejb.kuchenzutatbmp;

import java.rmi.RemoteException;
import java.util.ArrayList;
import javax.ejb.EJBLocalObject;

/**
 * Title:
 * Description:  Local-Interface der Kuchen-Bean.
 *               Enthlt nur die Methoden zum Setzen der Properties.
 *               Darf kein Remote-Home-Interface sein, da in beide Richtungen (von Kuchen zu Zutat und
 *               von Zutat zu Kuchen) referenziert werden kann.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface LocalKuchenBMP extends EJBLocalObject
{
  /**Abrufen der Kuchen-ID.
   * Es gibt keine Set-Methode dazu (weil es das PrimaryKey-Feld ist).
   * @return Die Kuchen-ID.
   */
  public Long getId() throws RemoteException;

  /**Abrufen des Kuchen-Namens.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getName() throws RemoteException;

  /**Setzen des Kuchen-Namens.
   * @param str_Name Neuer Name.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setName (String str_Name) throws RemoteException;

  /**Abrufen aller Zutaten dieses Kuchens.
   * Da hier mit BeanManagedPersistence gearbeitet wird, wird die Liste manuell als Liste von LocalInterfaces
   * erzeugt.
   * @return Collection von Zutat-Objekten.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public ArrayList getZutatenListe() throws RemoteException;

  /**Hinzufgen einer Zutat zu den Zutaten dieses Kuchens (die einzige Business-Methode).
   * Hier werden die relevanten Felder der Zutat bergeben, die Bean setzt selbst die Kuchen-Id.
   * @param str_ZutatName Name der Zutat.
   * @param str_Menge Erforderliche Menge
   * @return Die erzeugte Zutat.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutatBMP addZutat (String str_ZutatName, String str_Menge) throws RemoteException;
}