package com.knauf.ejb.kuchenzutatbmp;

import java.rmi.RemoteException;
import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.EJBLocalHome;
import javax.ejb.FinderException;

/**
 * Title:
 * Description:  Local-Home-Interface des leckeren Kuchens.
 *               Deklariert die diversen Create-Methoden.
 *               Darf kein Remote-Home-Interface sein, da in beide Richtungen (von Kuchen zu Zutat und
 *               von Zutat zu Kuchen) referenziert werden kann.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface LocalKuchenBMPHome extends EJBLocalHome
{
  /**Erzeugen eines Kuchen-Objekts, wobei der Name angegeben wird. Der Key wird automatisch erzeugt.
   * @param str_Name Der Name des Kuchens.
   * @return Der erzeugte Kuchen.
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalKuchenBMP createByName (String str_Name) throws CreateException, RemoteException;

  /**Laden eines Kuchen-Objekts anhand des Primary Keys.
   * @param lng_PrimaryKey Der Key des Kuchens.
   * @return Den anhand des Keys gefundenen Kuchen.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalKuchenBMP findByPrimaryKey(Long lng_PrimaryKey) throws FinderException, RemoteException;

  /**Laden aller Kuchen-Objekte.
   * @return Eine Collection aller Kuchen.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Collection findAll() throws FinderException, RemoteException;
}