package com.knauf.ejb.kuchenzutatbmp;

import java.rmi.RemoteException;
import javax.ejb.EJBLocalObject;

/**
 * Title:
 * Description:  Local-Interface der Kuchen-Zutat, Bean-Managed-Persistence-Variante.
 *               Darf kein Remote-Interface sein, da in beide Richtungen (von Kuchen zu Zutat und
 *               von Zutat zu Kuchen) referenziert werden kann.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface LocalZutatBMP extends EJBLocalObject
{
  /**Abrufen der Zutat-ID.
   * Es gibt keine Set-Methode dazu (weil es das PrimaryKey-Feld ist).
   * @return Die Zutat-ID.
   */
  public Long getId() throws RemoteException;

  /**Abrufen des Zutat-Namens.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getZutatName() throws RemoteException;

  /**Setzen des Zutat-Namens.
   * @param str_Name Neuer Name.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setZutatName (String str_Name) throws RemoteException;

  /**Abrufen der Menge (als String)
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getMenge() throws RemoteException;

  /**Setzen der menge als String
   * @param str_Menge Neue Menge
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setMenge (String str_Menge) throws RemoteException;

  /**Abrufen der Kuchen-ID
   * @return Die Kuchen-ID.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Long getKuchenId() throws RemoteException;

  /**Setzen der Kuchen-ID. Darf hier nicht abstrakt sein.
   * @param lng_KuchenId Die Kuchen-ID
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setKuchenId (Long lng_KuchenId) throws RemoteException;


  /**Abrufen des Kuchens, zu dem die Zutat gehrt.
   * @return Der Kuchen der Zutat.
   */
  public LocalKuchenBMP getKuchen() throws RemoteException;
}