package com.knauf.ejb.kuchenzutatbmp;

import java.rmi.RemoteException;
import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBLocalHome;

/**
 * Title:
 * Description:  Local-Home-Interface fr eine Zutat.
 *
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface LocalZutatBMPHome extends EJBLocalHome
{
  /**Erzeugen eines Zutat-Objekts, wobei Name und Menge angegeben wird. Der Key wird automatisch in
   * der Bean erzeugt.
   * @param str_Name Der Name der Zutat.
   * @param str_Menge Die Menge der Zutat
   * @param lng_KuchenId Die ID des zugehrigen Kuchens.
   * @return Die erzeugte Zutat
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutatBMP createByNameMengeKuchenId (String str_Name, String str_Menge, Long lng_KuchenId) throws CreateException, RemoteException;

  /**Laden einer Zutat anhand des Primary Keys.
   * @param lng_PrimaryKey Der Primrschlssel der Zutat, eine ID-Spalte vom Typ "Long".
   * @return Die anhand des Keys gefundenen Zutat.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalZutatBMP findByPrimaryKey(Long lng_PrimaryKey) throws FinderException, RemoteException;

  /**Laden aller Zutaten-Objekte eines Kuchens
   * @param lng_KuchenId Fr diesen Kuchen werden die Zutaten gesucht.
   * @return Eine Collection aller Zutaten eines Kuchens.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Collection findByKuchenId(Long lng_KuchenId) throws FinderException, RemoteException;
}