package com.knauf.ejb.messagebean;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.jms.*;
import javax.naming.InitialContext;

/**Hauptfenster der Beispielanwendung fr eine MessageDriven Bean
 *
 */
public class MessageFrame extends JFrame
{
  JPanel contentPane;
  JButton jButtonSend = new JButton();
  JLabel jLabelMessageText = new JLabel();
  JTextField jTextFieldMessageText = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**Construct the frame*/
  public MessageFrame()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception
  {
    jButtonSend.setText("Send !");
    jButtonSend.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonSend_actionPerformed(e);
      }
    });
    //setIconImage(Toolkit.getDefaultToolkit().createImage(MessageFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(gridBagLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("MessageFrame");
    jLabelMessageText.setText("Message-Text: ");
    contentPane.add(jLabelMessageText, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(15, 36, 0, 0), 41, 0));
    contentPane.add(jTextFieldMessageText, new GridBagConstraints(0, 0, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(15, 124, 0, 66), 206, 0));
    contentPane.add(jButtonSend, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(12, 95, 228, 66), 10, 0));
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  /**Button "Senden" wurde geklickt: Abschicken des Werts im Textfeld.
   * @param e ActionEvent
   */
  void jButtonSend_actionPerformed(ActionEvent e)
  {
    try
    {
      //JMS initialisieren. Die ConnectionFactory aus dem JNDI holen:
      InitialContext initialContext = new InitialContext();
      QueueConnectionFactory queueConnectionFactory = (QueueConnectionFactory)
        initialContext.lookup("java:comp/env/jms/MBConnectionFactory");

      //Die konfigurierte Queue holen:
      Queue queue = (Queue) initialContext.lookup("java:comp/env/jms/MBQueueRef");

      //Verbindung erzeugen:
      QueueConnection queueConnection = queueConnectionFactory.createQueueConnection();
      QueueSession queueSession = queueConnection.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
      QueueSender queueSender = queueSession.createSender(queue);

      //Senden der Nachricht:
      TextMessage textMessage = queueSession.createTextMessage();
      textMessage.setText ( this.jTextFieldMessageText.getText() );

      queueSender.send(textMessage);

      //Fertig.
      JOptionPane.showMessageDialog(this, "Nachricht wurde gesendet und sollte im Serverlog stehen !");
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
}