/*
 * Created on 14.11.2004
 *
 */
package com.knauf.ejb.nm;

import java.rmi.RemoteException;
import java.util.ArrayList;
import javax.ejb.EJBLocalObject;

/**
 * @author WKnauf
 *
 * Local Remote Interface der Buchstabe-Bean. 
 * Enthlt die Getter/Setter der Felder und die Methoden fr den Zugriff auf die
 * Worte. 
 */
public interface LocalBuchstabe extends EJBLocalObject
{
  /**Abrufen des Buchstabens.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getBuchstabe() throws RemoteException;

  /**Setzen des Buchstabe.
   * @param str_Buchstabe Neuer Buchstabe.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setBuchstabe (String str_Buchstabe) throws RemoteException;
  
  /**Abrufen aller Worte dieses Buchstabens.
   * WARNUNG: Die Wortliste darf nicht direkt als Collection zurckgeliefert werden,
   * die von der Bean-Methode "getWorte" kommt, sondern MUSS in eine ArrayList umgewandelt werden.
   * @return Collection von Wort-Objekten.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public ArrayList getWortListe() throws RemoteException;

  /**Hinzufgen eines Worts zu den Worten dieses Buchstabens (die einzige Business-Methode).
   * @param wort Das zuzufgende Wort.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void addWort (LocalWort wort) throws RemoteException;
}
