/*
 * Created on 14.11.2004
 *
 */
package com.knauf.ejb.nm;

import java.rmi.RemoteException;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.ejb.EJBLocalHome;
import javax.ejb.FinderException;

/**
 * @author WKnauf
 *
 * Local Interface der Bean "Buchstabe" mit den Finder-und Create-Methoden.
 */
public interface LocalBuchstabeHome extends EJBLocalHome
{
  /**Erzeugen eines Buchstabe-Objekts, wobei der Buchstabe angegeben wird. Der Key wird automatisch erzeugt.
   * @param str_Buchstabe Der Buchstabe. Sollte Unique sein.
   * @return Der erzeugte Buchstabe.
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalBuchstabe createByBuchstabe(String str_Buchstabe) throws CreateException, RemoteException;

  /**Erzeugen eines Buchstabe-Objekts ohne weitere Details. Der Key wird automatisch erzeugt.
   * Scheinbar nur ntig, weil der J2EE-Verifier sonst meckert.
   * @return Der erzeugte Buchstabe.
   * @exception CreateException Fehler beim Erzeugen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalBuchstabe create() throws CreateException, RemoteException;

  /**Laden eines Buchstabe-Objekts anhand des Primary Keys. Der Key wird vom Container verwaltet.
   * @param obj_PrimaryKey Der Key des Buchstaben.
   * @return Den anhand des Keys gefundene Buchstabe.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalBuchstabe findByPrimaryKey(Object obj_PrimaryKey) throws FinderException, RemoteException;

  /**Laden eines Buchstabe-Objekts anhand des Buchstabens (a-z).
   * @param str_Buchstabe Der Buchstabe. Darf entweder ein oder kein Objekt zurckliefern !
   * @return Den anhand des Keys gefundene Buchstabe.
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public LocalBuchstabe findByBuchstabe(String str_Buchstabe) throws FinderException, RemoteException;


  /**Laden aller Buchstabe-Objekte.
   * @return Eine Collection aller Buchstaben (genau 26 !)
   * @exception FinderException Fehler beim Finden.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public Collection findAll() throws FinderException, RemoteException;
}
