/*
 * Created on 14.11.2004
 *
 */
package com.knauf.ejb.nm;

import java.rmi.RemoteException;
import java.util.ArrayList;

import javax.ejb.EJBException;
import javax.ejb.EJBLocalObject;

/**
 * @author WKnauf
 *
 * Local Remote Interface der Wort-Bean. 
 * Enthlt die Getter/Setter der Felder und die Methoden fr den Zugriff auf die
 * Buchstaben. 
 */
public interface LocalWort extends EJBLocalObject
{
  /**Abrufen des Worts.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getWort() throws RemoteException;

  /**Setzen des Worts.
   * @param str_Wort Neues Wort.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void setWort (String str_Wort) throws RemoteException;
  
  /**Abrufen aller Buchstaben dieses Worts.
   * WARNUNG: Die Buchstabenliste darf nicht direkt als Collection zurckgeliefert werden,
   * die von der Bean-Methode "getBuchstaben" kommt, sondern MUSS in eine ArrayList umgewandelt werden.
   * @return Collection von Buchstabe-Objekten.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public ArrayList getBuchstabenListe() throws RemoteException;

  /**Hinzufgen eines Buchstabens zu den Buchstaben dieses Worts.
   * @param buchstabe Der zuzufgende Buchstabe.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void addBuchstabe (LocalBuchstabe buchstabe) throws RemoteException;
  
  /**Entfernen eines Buchstabens aus den Buchstaben dieses Worts.
   * @param buchstabe Der zu entfernende Buchstabe. Falls er nicht vorhanden ist,
   * wird eine EJB-Exception ausgelst.
   * @exception RemoteException Bei Netzwerkfehlern.
   * @exception EJBException Falls ein Buchstabe entfernt werden soll, der nicht in Collection vorhanden ist
   * (hier wre eine eigene Exception schner) 
   */
  public void removeBuchstabe (LocalBuchstabe buchstabe) throws RemoteException, EJBException;

}
