package com.knauf.ejb.security;

import java.awt.*;
import java.awt.event.*;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.*;

public class FrameSecurity extends JFrame
{
  JPanel contentPane;

  /**Home-Interface der Security-Bean. Wird im Konstruktor erzeugt. */
  private SecurityHome securityHome = null;
  JLabel jLabelExecute = new JLabel();
  JButton jButtonRole1 = new JButton();
  JButton jButtonRole2 = new JButton();
  JButton jButtonUnrestricted = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**Construct the frame*/
  public FrameSecurity()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      jbInit();

      InitialContext initialContext = new InitialContext();
      Object homeref = initialContext.lookup ("java:comp/env/ejb/SecurityBean");

      this.securityHome = (SecurityHome) PortableRemoteObject.narrow(homeref, SecurityHome.class);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception
  {
    jLabelExecute.setText("Execute Bean method restricted to....");
    //setIconImage(Toolkit.getDefaultToolkit().createImage(FrameSecurity.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(gridBagLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("SecurityCheck");
    jButtonRole1.setMaximumSize(new Dimension(110, 27));
    jButtonRole1.setMinimumSize(new Dimension(110, 27));
    jButtonRole1.setPreferredSize(new Dimension(110, 27));
    jButtonRole1.setText("Role 1");
    jButtonRole1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonRole1_actionPerformed(e);
      }
    });
    jButtonRole2.setMaximumSize(new Dimension(110, 27));
    jButtonRole2.setMinimumSize(new Dimension(110, 27));
    jButtonRole2.setPreferredSize(new Dimension(110, 27));
    jButtonRole2.setText("Role 2");
    jButtonRole2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonRole2_actionPerformed(e);
      }
    });
    jButtonUnrestricted.setMaximumSize(new Dimension(110, 27));
    jButtonUnrestricted.setMinimumSize(new Dimension(110, 27));
    jButtonUnrestricted.setPreferredSize(new Dimension(110, 27));
    jButtonUnrestricted.setText("Unrestricted");
    jButtonUnrestricted.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButtonUnrestricted_actionPerformed(e);
      }
    });
    contentPane.add(jLabelExecute, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
    contentPane.add(jButtonRole1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
    contentPane.add(jButtonRole2, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
    contentPane.add(jButtonUnrestricted, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0));
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  /**Klick auf den Button "Methode fr Rolle 1 aufrufen".
   * @param e ActionEvent.
   */
  void jButtonRole1_actionPerformed(ActionEvent e)
  {
    try
    {
      Security security = this.securityHome.create();

      security.performRestrictedToRole1();

      JOptionPane.showMessageDialog(this, "Aufruf erfolgreich !");
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  /**Klick auf den Button "Methode ausfhren, die auf Rolle 2 beschrnkt ist".
   * @param e ActionEVent
   */
  void jButtonRole2_actionPerformed(ActionEvent e)
  {
    try
    {
      Security security = this.securityHome.create();

      security.performRestrictedToRole2();

      JOptionPane.showMessageDialog(this, "Aufruf erfolgreich !");
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  /**Klick auf den Button "Methode ausfhren, die auf keine Rolle beschrnkt ist".
   * @param e ActionEVent
   */
  void jButtonUnrestricted_actionPerformed(ActionEvent e)
  {
    try
    {
      Security security = this.securityHome.create();

      security.performUnrestricted();

      JOptionPane.showMessageDialog(this, "Aufruf erfolgreich !");
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
}