package com.knauf.ejb.stateful;

import java.rmi.RemoteException;
import javax.ejb.EJBObject;

/**
 * Title:
 * Description:  Remote-Interface fr GeometricModel-Store.
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public interface GeometricModelStore extends EJBObject
{
  /**Hinzufgen eines Satzes von Kantenlngen zur gespeicherten Menge an Berechnungen.
   * @param a Kantenlnge von a
   * @param b Kantenlnge von b
   * @param c Kantenlnge von c
   * @exception InvalidParameterException Falls a oder b oder c <= 0 sind.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public void addCalculation (double a, double b, double c) throws InvalidParameterException, RemoteException;

  /**Alle bisher erfolgten Berechnungen in einen String der Form
   *    "Anfrage x: a/b/c"
   * bringen.
   * Als Zeilentrenner dient "\n<br>".
   * @return String der bisher erfolgten Berechnungen.
   * @exception RemoteException Bei Netzwerkfehlern.
   */
  public String getAllCalculations() throws RemoteException;

}