package com.knauf.ejb.stateful;

import java.util.Vector;
import java.util.logging.Logger;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2004
 * Company:
 * @author
 * @version 1.0
 */

public class GeometricModelStoreBean implements SessionBean
{
  /**Der Session-Context */
  private SessionContext sessionContext = null;
  /**Vector fr Kantenlngen-Tripel: Kante a */
  private Vector vectorA = null;
  /**Vector fr Kantenlngen-Tripel: Kante b */
  private Vector vectorB = null;
  /**Vector fr Kantenlngen-Tripel: Kante c */
  private Vector vectorC = null;

  /**Der Logger fr Logausgaben dieser Klasse */
  private static final Logger logger = Logger.getLogger ( GeometricModelStoreBean.class.getName() );

  /**Konstruktor. Macht nichts.
   *
   */
  public GeometricModelStoreBean()
  {
  }

  ////////////////////////////////////////////////////////////////////
  //          Methoden aus Interface SessionBean                    //
  ////////////////////////////////////////////////////////////////////

  /**Setzen des SessionContexts.
   * @param ctx Der neue Session Context.
   */
  public void setSessionContext (SessionContext ctx)
  {
    logger.info ("setSessionContext");
    this.sessionContext = ctx;
  }


  /**Passivieren der Bean. Nix zu tun
   *
   */
  public void ejbPassivate()
  {
    logger.info ("passivate GeometricModelBean");
  }

  /**Aktivieren der Bean. Nix zu tun
   *
   */
  public void ejbActivate()
  {
    logger.info ("activate GeometricModelBean");
  }

  /**Entfernen der Bean. Nichts zu tun.
   *
   */
  public void ejbRemove()
  {
    logger.info ("remove GeometricModelBean");
  }

  ///////////////////////////////////////////////////////////////////
  //         Methoden aus Home-Interface                           //
  ///////////////////////////////////////////////////////////////////

  /**Create aus den Home-Interfaces.
   * Erzeugen der drei Kantenlngen-Vektoren.
   * @exception CreateException Fehler beim Erzeugen.
   */
  public void ejbCreate() throws javax.ejb.CreateException
  {
    GeometricModelStoreBean.logger.info ("ejbCreate");

    //Vector initialisieren:
    this.vectorA = new Vector();
    this.vectorB = new Vector();
    this.vectorC = new Vector();
  }

  ///////////////////////////////////////////////////////////////////
  //           Methoden aus Remote-Interface                       //
  ///////////////////////////////////////////////////////////////////


  /**Hinzufgen eines Satzes von Kantenlngen zur gespeicherten Menge an Berechnungen.
   * @param a Kantenlnge von a
   * @param b Kantenlnge von b
   * @param c Kantenlnge von c
   * @exception InvalidParameterException Falls a oder b oder c <= 0 sind.
   */
  public void addCalculation (double a, double b, double c) throws InvalidParameterException
  {
    if (a <= 0|| b <= 0 || c <= 0)
      throw new InvalidParameterException ("Seitenlnge <= 0");

    this.vectorA.add ( new Double (a) );
    this.vectorB.add ( new Double (b) );
    this.vectorC.add ( new Double (c) );
  }

  /**Alle bisher erfolgten Berechnungen in einen String der Form
   *    "Anfrage x: a/b/c"
   * bringen.
   * Als Zeilentrenner dient "\n<br>".
   * @return String der bisher erfolgten Berechnungen.
   */
  public String getAllCalculations ()
  {
    String strReturn = "";
    for (int intIndex = 0; intIndex < this.vectorA.size(); intIndex ++)
    {
      if (intIndex > 0)
        strReturn += "<br>\r\n";
      strReturn += "Anfrage " + intIndex + ": " + this.vectorA.get (intIndex) + "/" + this.vectorB.get (intIndex) + "/" + this.vectorC.get (intIndex);
    }

    return strReturn;
  }
}